// Generated by CoffeeScript 1.7.1
(function() {
  var ApplicationManager, RepoManager, helpers;

  require('colors');

  helpers = require('./helpers');

  RepoManager = require('./repository').RepoManager;

  ApplicationManager = require('./application').ApplicationManager;

  exports.ProjectManager = (function() {
    function ProjectManager() {}

    ProjectManager.prototype.repoManager = new RepoManager();

    ProjectManager.prototype.appManager = new ApplicationManager();

    ProjectManager.prototype.newProject = function(name, isCoffee, url, user, password, callback) {
      var credentials;
      credentials = {
        password: password,
        username: user
      };
      return this.repoManager.createGithubRepo(credentials, name, (function(_this) {
        return function() {
          return _this.repoManager.createLocalRepo(name, isCoffee, function() {
            return _this.repoManager.connectRepos(user, name, function() {
              return _this.repoManager.saveConfig(user, name, url, function() {
                return callback();
              });
            });
          });
        };
      })(this));
    };

    ProjectManager.prototype.deploy = function(config, password, callback) {
      var install, name, repoName, update, url, user;
      name = config.cozy.appName;
      url = config.cozy.url;
      user = config.github.user;
      repoName = config.github.repoName;
      install = (function(_this) {
        return function() {
          var repoUrl;
          repoUrl = "https://github.com/" + user + "/" + repoName + ".git";
          return _this.appManager.installApp(name, url, repoUrl, password, function() {
            return callback();
          });
        };
      })(this);
      update = (function(_this) {
        return function() {
          return _this.appManager.updateApp(name, url, password, function() {
            return callback();
          });
        };
      })(this);
      return this.appManager.isInstalled(name, url, password, function(err, isInstalled) {
        if (err) {
          return console.log("Error occured while connecting" + "to your Cozy Cloud.".red);
        } else if (isInstalled) {
          return update();
        } else {
          return install();
        }
      });
    };

    return ProjectManager;

  })();

}).call(this);
